Bug 218433 - umovestr I/O errors on 32-bit binaries
umovestr I/O errors on 32-bit binaries
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: strace (Show other bugs)
rawhide
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Roland McGrath
Brian Brock
:
Depends On: 218043
Blocks:
  Show dependency treegraph
 
Reported: 2006-12-05 06:03 EST by Jakub Jelinek
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version: 4.5.15-1
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-01-16 22:05:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Jakub Jelinek 2006-12-05 06:03:20 EST
+++ This bug was initially created as a clone of Bug #218043 +++

strace-4.5.14-0.EL4.1.x86_64

On x86-64, with a 32-bit binary.

1. gcc -m32 -o writex writex.c
2. sudo strace -o foo -v ./writevx 127.0.0.1 22
[ Process PID=4407 runs in 32 bit mode. ]
umovestr: Input/output error
umovestr: Input/output error

-- Additional comment from bnocera@redhat.com on 2006-12-01 10:07 EST --
Created an attachment (id=142573)
writevx.c


-- Additional comment from jakub@redhat.com on 2006-12-05 04:11 EST --
Even:
#include <sys/uio.h>

int
main (void)
{
  struct iovec v[2];
  v[0].iov_base = "abc";
  v[0].iov_len = 3;
  v[1].iov_base = "\n";
  v[1].iov_len = 1;
  writev (1, v, 2);
  return 0;
}
is enough to reproduce it.  64-bit strace just doesn't handle 32-bit
{read,write}v.

-- Additional comment from jakub@redhat.com on 2006-12-05 05:57 EST --
Created an attachment (id=142820)
strace-biarch-iovec.patch

Patch to fix it.  biarch support in current strace is clearly a hack, but until
if ever that is rewritten into a framework that can naturally cope with this,
I wrote a hack solution just for struct iovec.
Comment 1 Dmitry V. Levin 2006-12-05 21:11:45 EST
Hmm...
What about struct timespec (#171626) and struct timeval (#173050)?
Comment 2 Roland McGrath 2006-12-06 00:31:59 EST
many are scrod for biarch and mostly i say tough luck.
each individual flavor done with a kludge helps some, but i haven't been willing
to write all the kludges myself.
Comment 3 Dmitry V. Levin 2006-12-13 16:32:09 EST
Fixed upstream.
Comment 4 Roland McGrath 2007-01-11 06:14:49 EST
these bugs are fixed upstream in the coming 4.5.15 release
Comment 5 Roland McGrath 2007-01-16 22:05:33 EST
4.5.15 in rawhide and in updates for fc5 and fc6 fixes this.

Note You need to log in before you can comment on or make changes to this bug.